<template>
    <div id="show-blogs">
        <h1>All Blog Articles</h1>
        <input type="text" v-model="search" placeholder="Search ">
            <div v-for="blog in filteredBlogs" :key="blog.id" class="single-blog">
                <router-link v-bind:to="'/blog' + blog.id"><h2 v-rainbow>{{ blog.title | to-uppercase }}</h2></router-link>
                <article>{{ blog.body | snipper }}</article>
            </div>
    </div>
</template>

<script>
export default {
    data () {
        return {
            blogs: [],
            search: ''
        }
    },
    methods: {
    },
    created() {
        this.$http.get('http://jsonplaceholder.typicode.com/posts').then(function(data){
            this.blogs = data.body.slice(0,10);
        });
    },
    // Computed property
    computed: {
        filteredBlogs:function(){
            return this.blogs.filter((blog) => {
                // Function check character in js
                return blog.title.match(this.search);
            });
        }
    },
    filers: {
        toUpperCase(value){
            return value.toUpperCase();
        }
    },
    directives: {
        'rainbow': {
            bind(el){
                el.style.color = "#" + Math.random().toString(16).slice(2, 8);
            }
        }
    }
}
</script>

<style>
#show-blogs{
    max-width: 800px;
    margin: 0px auto;
}
.single-blog{
    padding: 20px;
    margin: 20px 0;
    box-sizing: border-box;
    background: #eee;
}
</style>